package de.hft.stuttgart.citydoctor2.gui.tree;

import de.hft.stuttgart.citydoctor2.datastructure.TransportationObject;
import de.hft.stuttgart.citydoctor2.gui.CheckStatus;
import de.hft.stuttgart.citydoctor2.gui.Renderer;

public class TransportationObjectNode extends Renderable {

    private final TransportationObject to;

    public TransportationObjectNode(TransportationObject to) {
        this.to = to;
    }

    @Override
    public String getText() {
        return to.getGmlId().getGmlString();
    }

    @Override
    public void visit(Renderer renderer) {
        renderer.render(to);
    }

    @Override
    public void refreshTextColor() {
        if (!to.isValidated()) {
            setStatus(CheckStatus.NOT_CHECKED);
        } else if (to.containsAnyError()) {
            setStatus(CheckStatus.ERROR);
        } else {
            setStatus(CheckStatus.OK);
        }
    }
}
